﻿
Public Class TecBitmap

#Region "New"

    Public Random As New Random

    Private Sub TecBitmap_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.AllowDrop = True
    End Sub

#End Region

#Region "Action"

    Private Sub TecBitmap_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragEnter

        Dim Path As String = CType(e.Data.GetData(DataFormats.FileDrop), String())(0)

        If e.Data.GetDataPresent(DataFormats.FileDrop) = False Then
            Return
        End If

        e.Effect = DragDropEffects.Copy
    End Sub

    Private Sub TecBitmap_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragDrop

        Dim Path As String = CType(e.Data.GetData(DataFormats.FileDrop), String())(0)
        If IO.Directory.Exists(Path) Then
            Cursor = Cursors.WaitCursor
            ConvImage(Path, ".png", 300, 300, True)
            ConvImage(Path, ".jpg", 640, 480, False)
            Cursor = Cursors.Default
        End If
    End Sub

    Public Sub ConvImage(ByVal Path As String, ByVal Ext As String, ByVal SizeX As Integer, ByVal SizeY As Integer, ByVal Circle As Boolean)

        Dim Name As String = Trim(txtName.Text)
        Dim Number As Integer = Val(txtNumber.Text)

        Dim Work() As String = IO.Directory.GetFiles(Path, "*" & Ext)
        For Each pt As String In Work
            My.Computer.FileSystem.RenameFile(pt, "Z" & IO.Path.GetFileName(pt))
        Next
        Work = Shuffle(IO.Directory.GetFiles(Path, "*" & Ext))

        For Each pt As String In Work
            Using Bitmap As New Bitmap(SizeX, SizeY)
                Using Image As New Bitmap(pt)
                    RotateJpg(Image)
                    Using g As Graphics = Graphics.FromImage(Bitmap)
                        g.FillRectangle(SystemBrushes.Control, New Rectangle(0, 0, Bitmap.Width, Bitmap.Height))
                        Using gp As New System.Drawing.Drawing2D.GraphicsPath()
                            gp.AddEllipse(New Rectangle(0, 0, SizeX, SizeY))
                            Using rgn As New Region(gp)
                                If Circle Then
                                    g.Clip = rgn
                                End If
                                Dim sx As Integer = Image.Width
                                Dim sy As Integer = Image.Height
                                If Image.Width > Image.Height Then
                                    sx -= SizeX / SizeY * Image.Height
                                    sy -= Image.Height
                                Else
                                    sy -= SizeY / SizeX * Image.Width
                                    sx -= Image.Width
                                End If
                                g.DrawImage(Image, New Rectangle(0, 0, Bitmap.Width, Bitmap.Height), New Rectangle(sx / 2, sy / 2, Image.Width - sx, Image.Height - sy), GraphicsUnit.Pixel)
                            End Using
                        End Using
                    End Using
                End Using
                IO.File.Delete(pt)
                Dim Line() As String = Split(IO.Path.GetFileNameWithoutExtension(pt), "_")
                ReDim Preserve Line(1)
                Bitmap.Save(Path & "\" & Name & Format(Number, "0000") & IIf(Line(1) <> "", "_", "") & Line(1) & Ext)
                Number += 1
            End Using
        Next
    End Sub

    Public Sub RotateJpg(ByVal Bitmap As Bitmap)

        Try
            Dim item As System.Drawing.Imaging.PropertyItem
            For Each item In Bitmap.PropertyItems

                If (item.Id = &H112) Then
                    Select Case item.Value(0)

                        Case 2 : Bitmap.RotateFlip(RotateFlipType.RotateNoneFlipY)
                        Case 3 : Bitmap.RotateFlip(RotateFlipType.Rotate180FlipNone)
                        Case 4 : Bitmap.RotateFlip(RotateFlipType.RotateNoneFlipX)
                        Case 5 : Bitmap.RotateFlip(RotateFlipType.Rotate270FlipY)
                        Case 6 : Bitmap.RotateFlip(RotateFlipType.Rotate90FlipNone)
                        Case 7 : Bitmap.RotateFlip(RotateFlipType.Rotate90FlipY)
                        Case 8 : Bitmap.RotateFlip(RotateFlipType.Rotate270FlipNone)
                    End Select
                End If
            Next
        Catch ex As Exception
        End Try
    End Sub

    Public Function Shuffle(ByVal List() As String) As String()

        If chkShuffle.Checked Then
            For ct As Integer = 0 To 10000
                Dim no1 As Integer = Random.Next(List.Count)
                Dim no2 As Integer = Random.Next(List.Count)
                Dim Work As String = List(no1)
                List(no1) = List(no2)
                List(no2) = Work
            Next
        End If
        Return List
    End Function
#End Region

End Class